package de.humance.eco.profile.model.impl;

import com.liferay.portal.kernel.bean.AutoEscapeBeanHandler;
import com.liferay.portal.kernel.exception.SystemException;
import com.liferay.portal.kernel.util.GetterUtil;
import com.liferay.portal.kernel.util.ProxyUtil;
import com.liferay.portal.kernel.util.StringBundler;
import com.liferay.portal.model.CacheModel;
import com.liferay.portal.model.impl.BaseModelImpl;
import com.liferay.portal.service.ServiceContext;
import com.liferay.portal.util.PortalUtil;

import com.liferay.portlet.expando.model.ExpandoBridge;
import com.liferay.portlet.expando.util.ExpandoBridgeFactoryUtil;

import de.humance.eco.profile.model.VehicleUser;
import de.humance.eco.profile.model.VehicleUserModel;

import java.io.Serializable;

import java.sql.Types;

import java.util.HashMap;
import java.util.Map;

/**
 * The base model implementation for the VehicleUser service. Represents a row in the &quot;Profile_VehicleUser&quot; database table, with each column mapped to a property of this class.
 *
 * <p>
 * This implementation and its corresponding interface {@link de.humance.eco.profile.model.VehicleUserModel} exist only as a container for the default property accessors generated by ServiceBuilder. Helper methods and all application logic should be put in {@link VehicleUserImpl}.
 * </p>
 *
 * @author Humance
 * @see VehicleUserImpl
 * @see de.humance.eco.profile.model.VehicleUser
 * @see de.humance.eco.profile.model.VehicleUserModel
 * @generated
 */
public class VehicleUserModelImpl extends BaseModelImpl<VehicleUser>
    implements VehicleUserModel {
    /*
     * NOTE FOR DEVELOPERS:
     *
     * Never modify or reference this class directly. All methods that expect a vehicle user model instance should use the {@link de.humance.eco.profile.model.VehicleUser} interface instead.
     */
    public static final String TABLE_NAME = "Profile_VehicleUser";
    public static final Object[][] TABLE_COLUMNS = {
            { "vehicleUserId", Types.BIGINT },
            { "userId", Types.BIGINT },
            { "vehicleId", Types.BIGINT }
        };
    public static final String TABLE_SQL_CREATE = "create table Profile_VehicleUser (vehicleUserId LONG not null primary key,userId LONG,vehicleId LONG)";
    public static final String TABLE_SQL_DROP = "drop table Profile_VehicleUser";
    public static final String ORDER_BY_JPQL = " ORDER BY vehicleUser.userId ASC";
    public static final String ORDER_BY_SQL = " ORDER BY Profile_VehicleUser.userId ASC";
    public static final String DATA_SOURCE = "liferayDataSource";
    public static final String SESSION_FACTORY = "liferaySessionFactory";
    public static final String TX_MANAGER = "liferayTransactionManager";
    public static final boolean ENTITY_CACHE_ENABLED = GetterUtil.getBoolean(com.liferay.util.service.ServiceProps.get(
                "value.object.entity.cache.enabled.de.humance.eco.profile.model.VehicleUser"),
            true);
    public static final boolean FINDER_CACHE_ENABLED = GetterUtil.getBoolean(com.liferay.util.service.ServiceProps.get(
                "value.object.finder.cache.enabled.de.humance.eco.profile.model.VehicleUser"),
            true);
    public static final boolean COLUMN_BITMASK_ENABLED = GetterUtil.getBoolean(com.liferay.util.service.ServiceProps.get(
                "value.object.column.bitmask.enabled.de.humance.eco.profile.model.VehicleUser"),
            true);
    public static long USERID_COLUMN_BITMASK = 1L;
    public static long VEHICLEID_COLUMN_BITMASK = 2L;
    public static final long LOCK_EXPIRATION_TIME = GetterUtil.getLong(com.liferay.util.service.ServiceProps.get(
                "lock.expiration.time.de.humance.eco.profile.model.VehicleUser"));
    private static ClassLoader _classLoader = VehicleUser.class.getClassLoader();
    private static Class<?>[] _escapedModelInterfaces = new Class[] {
            VehicleUser.class
        };
    private long _vehicleUserId;
    private String _vehicleUserUuid;
    private long _userId;
    private String _userUuid;
    private long _originalUserId;
    private boolean _setOriginalUserId;
    private long _vehicleId;
    private long _originalVehicleId;
    private boolean _setOriginalVehicleId;
    private long _columnBitmask;
    private VehicleUser _escapedModel;

    public VehicleUserModelImpl() {
    }

    @Override
    public long getPrimaryKey() {
        return _vehicleUserId;
    }

    @Override
    public void setPrimaryKey(long primaryKey) {
        setVehicleUserId(primaryKey);
    }

    @Override
    public Serializable getPrimaryKeyObj() {
        return _vehicleUserId;
    }

    @Override
    public void setPrimaryKeyObj(Serializable primaryKeyObj) {
        setPrimaryKey(((Long) primaryKeyObj).longValue());
    }

    @Override
    public Class<?> getModelClass() {
        return VehicleUser.class;
    }

    @Override
    public String getModelClassName() {
        return VehicleUser.class.getName();
    }

    @Override
    public Map<String, Object> getModelAttributes() {
        Map<String, Object> attributes = new HashMap<String, Object>();

        attributes.put("vehicleUserId", getVehicleUserId());
        attributes.put("userId", getUserId());
        attributes.put("vehicleId", getVehicleId());

        return attributes;
    }

    @Override
    public void setModelAttributes(Map<String, Object> attributes) {
        Long vehicleUserId = (Long) attributes.get("vehicleUserId");

        if (vehicleUserId != null) {
            setVehicleUserId(vehicleUserId);
        }

        Long userId = (Long) attributes.get("userId");

        if (userId != null) {
            setUserId(userId);
        }

        Long vehicleId = (Long) attributes.get("vehicleId");

        if (vehicleId != null) {
            setVehicleId(vehicleId);
        }
    }

    @Override
    public long getVehicleUserId() {
        return _vehicleUserId;
    }

    @Override
    public void setVehicleUserId(long vehicleUserId) {
        _vehicleUserId = vehicleUserId;
    }

    @Override
    public String getVehicleUserUuid() throws SystemException {
        return PortalUtil.getUserValue(getVehicleUserId(), "uuid",
            _vehicleUserUuid);
    }

    @Override
    public void setVehicleUserUuid(String vehicleUserUuid) {
        _vehicleUserUuid = vehicleUserUuid;
    }

    @Override
    public long getUserId() {
        return _userId;
    }

    @Override
    public void setUserId(long userId) {
        _columnBitmask = -1L;

        if (!_setOriginalUserId) {
            _setOriginalUserId = true;

            _originalUserId = _userId;
        }

        _userId = userId;
    }

    @Override
    public String getUserUuid() throws SystemException {
        return PortalUtil.getUserValue(getUserId(), "uuid", _userUuid);
    }

    @Override
    public void setUserUuid(String userUuid) {
        _userUuid = userUuid;
    }

    public long getOriginalUserId() {
        return _originalUserId;
    }

    @Override
    public long getVehicleId() {
        return _vehicleId;
    }

    @Override
    public void setVehicleId(long vehicleId) {
        _columnBitmask |= VEHICLEID_COLUMN_BITMASK;

        if (!_setOriginalVehicleId) {
            _setOriginalVehicleId = true;

            _originalVehicleId = _vehicleId;
        }

        _vehicleId = vehicleId;
    }

    public long getOriginalVehicleId() {
        return _originalVehicleId;
    }

    public long getColumnBitmask() {
        return _columnBitmask;
    }

    @Override
    public ExpandoBridge getExpandoBridge() {
        return ExpandoBridgeFactoryUtil.getExpandoBridge(0,
            VehicleUser.class.getName(), getPrimaryKey());
    }

    @Override
    public void setExpandoBridgeAttributes(ServiceContext serviceContext) {
        ExpandoBridge expandoBridge = getExpandoBridge();

        expandoBridge.setAttributes(serviceContext);
    }

    @Override
    public VehicleUser toEscapedModel() {
        if (_escapedModel == null) {
            _escapedModel = (VehicleUser) ProxyUtil.newProxyInstance(_classLoader,
                    _escapedModelInterfaces, new AutoEscapeBeanHandler(this));
        }

        return _escapedModel;
    }

    @Override
    public Object clone() {
        VehicleUserImpl vehicleUserImpl = new VehicleUserImpl();

        vehicleUserImpl.setVehicleUserId(getVehicleUserId());
        vehicleUserImpl.setUserId(getUserId());
        vehicleUserImpl.setVehicleId(getVehicleId());

        vehicleUserImpl.resetOriginalValues();

        return vehicleUserImpl;
    }

    @Override
    public int compareTo(VehicleUser vehicleUser) {
        int value = 0;

        if (getUserId() < vehicleUser.getUserId()) {
            value = -1;
        } else if (getUserId() > vehicleUser.getUserId()) {
            value = 1;
        } else {
            value = 0;
        }

        if (value != 0) {
            return value;
        }

        return 0;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }

        if (!(obj instanceof VehicleUser)) {
            return false;
        }

        VehicleUser vehicleUser = (VehicleUser) obj;

        long primaryKey = vehicleUser.getPrimaryKey();

        if (getPrimaryKey() == primaryKey) {
            return true;
        } else {
            return false;
        }
    }

    @Override
    public int hashCode() {
        return (int) getPrimaryKey();
    }

    @Override
    public void resetOriginalValues() {
        VehicleUserModelImpl vehicleUserModelImpl = this;

        vehicleUserModelImpl._originalUserId = vehicleUserModelImpl._userId;

        vehicleUserModelImpl._setOriginalUserId = false;

        vehicleUserModelImpl._originalVehicleId = vehicleUserModelImpl._vehicleId;

        vehicleUserModelImpl._setOriginalVehicleId = false;

        vehicleUserModelImpl._columnBitmask = 0;
    }

    @Override
    public CacheModel<VehicleUser> toCacheModel() {
        VehicleUserCacheModel vehicleUserCacheModel = new VehicleUserCacheModel();

        vehicleUserCacheModel.vehicleUserId = getVehicleUserId();

        vehicleUserCacheModel.userId = getUserId();

        vehicleUserCacheModel.vehicleId = getVehicleId();

        return vehicleUserCacheModel;
    }

    @Override
    public String toString() {
        StringBundler sb = new StringBundler(7);

        sb.append("{vehicleUserId=");
        sb.append(getVehicleUserId());
        sb.append(", userId=");
        sb.append(getUserId());
        sb.append(", vehicleId=");
        sb.append(getVehicleId());
        sb.append("}");

        return sb.toString();
    }

    @Override
    public String toXmlString() {
        StringBundler sb = new StringBundler(13);

        sb.append("<model><model-name>");
        sb.append("de.humance.eco.profile.model.VehicleUser");
        sb.append("</model-name>");

        sb.append(
            "<column><column-name>vehicleUserId</column-name><column-value><![CDATA[");
        sb.append(getVehicleUserId());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>userId</column-name><column-value><![CDATA[");
        sb.append(getUserId());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>vehicleId</column-name><column-value><![CDATA[");
        sb.append(getVehicleId());
        sb.append("]]></column-value></column>");

        sb.append("</model>");

        return sb.toString();
    }
}
